import RPi.GPIO as GPIO
import time

portarray1 = [11,12,13,15,16,18,22,7]
portarray2 = [24,5,3,23,21,19,8,10]

#alt portarray2 setup depending on jumper
#portarray2 = [24,26,3,23,21,19,8,10]

def portout (port, value, mask):
    idx = 0
    while idx < 8:
        tempmask = 0x01 << idx
        if (mask & tempmask == tempmask):
            if (port == 1):
                pin = portarray1[idx]
            if (port == 2):
                pin = portarray2[idx]
            GPIO.setup(pin, GPIO.OUT)
            if (value & tempmask == tempmask):
                GPIO.output(pin, True)
            else:
                GPIO.output(pin, False)
        idx = idx + 1
    return

def portin(port, mask):
    idx = 0
    retval = 0
    while idx < 8:
        tempmask = 0x01 << idx
        if (mask & tempmask == tempmask):
            if (port == 1):
                pin = portarray1[idx]
            if (port == 2):
                pin = portarray2[idx]
            GPIO.setup(pin, GPIO.IN)
            if (GPIO.input(pin)):
                retval = retval | (0x01 << idx)
        idx = idx + 1
    return retval


output = 0
while output < 256:
    portout(1,output,0xFF)
    portout(2,output,0xFF)
    #time.sleep(1)      #1sec delay
    output = output + 1



while 1:
    temp = portin(1, 0xFF)
    portout(2,temp,0xFF)
